| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | List of all members
CommonAuditor Class Referenceabstract

Base class with common functionalities shared by few auditor implementations. More...

`#include <src/CommonAuditor.h>`

Inheritance diagram for CommonAuditor:
[legend]
Collaboration diagram for CommonAuditor:
[legend]

## Public Member Functions
| Auditor (const std::string &name, ISvcLocator *svcloc)
| Constructor. More...
| Auditor (const Auditor &a)=delete
| Constructor. More...
"before" Auditor hooks
The default behavior is to fall back on the version accepting 2 strings, which must be implemented in the derived class.
void | before (StandardEventType evt, const std::string &caller) override
void | before (StandardEventType evt, INamedInterface *caller) override
void | before (CustomEventTypeRef evt, const std::string &caller) override
void | before (CustomEventTypeRef evt, INamedInterface *caller) override
"after" Auditor hooks
The default behavior is to fall back on the version accepting 2 strings, which must be implemented in the derived class.
void | after (StandardEventType evt, const std::string &caller, const StatusCode &sc) override
void | after (StandardEventType evt, INamedInterface *caller, const StatusCode &sc) override
void | after (CustomEventTypeRef evt, const std::string &caller, const StatusCode &sc) override
void | after (CustomEventTypeRef evt, INamedInterface *caller, const StatusCode &sc) override
Public Member Functions inherited from Auditor
| Auditor (const std::string &name, ISvcLocator *svcloc)
| Constructor. More...
| Auditor (const Auditor &a)=delete
Auditor & | operator= (const Auditor &rhs)=delete
StatusCode | sysInitialize () override
| Initialization method invoked by the framework. More...
StatusCode | sysFinalize () override
| Finalization method invoked by the framework. More...
void | before (StandardEventType, INamedInterface *) override
| The following methods are meant to be implemented by the child class... More...
void | before (StandardEventType, const std::string &) override
void | before (CustomEventTypeRef, INamedInterface *) override
void | before (CustomEventTypeRef, const std::string &) override
void | after (StandardEventType, INamedInterface *, const StatusCode &) override
void | after (StandardEventType, const std::string &, const StatusCode &) override
void | after (CustomEventTypeRef, INamedInterface *, const StatusCode &) override
void | after (CustomEventTypeRef, const std::string &, const StatusCode &) override
void | beforeInitialize (INamedInterface *) override
void | afterInitialize (INamedInterface *) override
void | beforeReinitialize (INamedInterface *) override
void | afterReinitialize (INamedInterface *) override
void | beforeExecute (INamedInterface *) override
void | afterExecute (INamedInterface *, const StatusCode &) override
void | beforeFinalize (INamedInterface *) override
void | afterFinalize (INamedInterface *) override
void | beforeBeginRun (INamedInterface *) override
void | afterBeginRun (INamedInterface *) override
void | beforeEndRun (INamedInterface *) override
void | afterEndRun (INamedInterface *) override
virtual StatusCode | initialize ()
virtual StatusCode | finalize ()
const std::string & | name () const override
bool | isEnabled () const override
SmartIF< ISvcLocator > & | serviceLocator () const override
| The standard service locator. More...
template<class T >
StatusCode | service (const std::string &name, T *&svc, bool createIf=false) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T = IService>
SmartIF< T > | service (const std::string &name, bool createIf=false) const
StatusCode | setProperties ()
| Set the auditor's properties. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IAuditor, IProperty > > >
| PropertyHolder ()=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Public Member Functions inherited from CommonMessaging< implements< IAuditor, IProperty > >
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const
| Backward compatibility function for getting the output level. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...

## Protected Member Functions
virtual void | i_before (CustomEventTypeRef evt, const std::string &caller)=0
| catch all "before" method, implemented in the derived class More...
virtual void | i_after (CustomEventTypeRef evt, const std::string &caller, const StatusCode &sc)=0
| catch all "after" method, implemented in the derived class More...
bool | i_auditEventType (const std::string &evt)
| Check if we are requested to audit the passed event type. More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IAuditor, IProperty > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IAuditor, IProperty > >
MSG::Level | setUpMessaging () const
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...

## Private Member Functions
void | deprecated_property (Gaudi::Details::PropertyBase &p)

## Private Attributes
Gaudi::Property< std::vector< std::string > > | m_types
Gaudi::Property< std::vector< std::string > > | m_customTypes

## Additional Inherited Members
Public Types inherited from Auditor
using | Factory = Gaudi::PluginService::Factory< IAuditor *(const std::string &, ISvcLocator *)>
Public Types inherited from PropertyHolder< CommonMessaging< implements< IAuditor, IProperty > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IAuditor, IProperty > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IAuditor, IProperty > >
using | base_class = CommonMessaging

## Detailed Description

Base class with common functionalities shared by few auditor implementations.

Author
  Marco Clemencic

Definition at line 8 of file CommonAuditor.h.

## Member Function Documentation

## ◆ after() [1/4]

void CommonAuditor::after | ( | StandardEventType | evt,
|  | const std::string & | caller,
|  | const StatusCode & | sc
| ) |  |
| override

Definition at line 18 of file CommonAuditor.cpp.

18 {
19 after( toStr( evt ), caller, sc );
20 }
toStr
const char * toStr(IAuditor::StandardEventType e)
Simple mapping function from IAuditor::StandardEventType to string.
Definition: IAuditor.h:99
CommonAuditor::after
void after(StandardEventType evt, const std::string &caller, const StatusCode &sc) override
Definition: CommonAuditor.cpp:18
IOTest.evt
evt
Definition: IOTest.py:94

## ◆ after() [2/4]

void CommonAuditor::after | ( | StandardEventType | evt,
|  | INamedInterface * | caller,
|  | const StatusCode & | sc
| ) |  |
| override

Definition at line 15 of file CommonAuditor.cpp.

15 {
16 if ( caller ) after( toStr( evt ), caller->name(), sc );
17 }
toStr
const char * toStr(IAuditor::StandardEventType e)
Simple mapping function from IAuditor::StandardEventType to string.
Definition: IAuditor.h:99
INamedInterface::name
virtual const std::string & name() const =0
Retrieve the name of the instance.
CommonAuditor::after
void after(StandardEventType evt, const std::string &caller, const StatusCode &sc) override
Definition: CommonAuditor.cpp:18
IOTest.evt
evt
Definition: IOTest.py:94

## ◆ after() [3/4]

void CommonAuditor::after | ( | CustomEventTypeRef | evt,
|  | const std::string & | caller,
|  | const StatusCode & | sc
| ) |  |
| override

Definition at line 24 of file CommonAuditor.cpp.

24 {
25 if ( i_auditEventType( evt ) ) i_after( evt, caller, sc );
26 }
CommonAuditor::i_auditEventType
bool i_auditEventType(const std::string &evt)
Check if we are requested to audit the passed event type.
Definition: CommonAuditor.h:42
CommonAuditor::i_after
virtual void i_after(CustomEventTypeRef evt, const std::string &caller, const StatusCode &sc)=0
catch all "after" method, implemented in the derived class
IOTest.evt
evt
Definition: IOTest.py:94

## ◆ after() [4/4]

void CommonAuditor::after | ( | CustomEventTypeRef | evt,
|  | INamedInterface * | caller,
|  | const StatusCode & | sc
| ) |  |
| override

Definition at line 21 of file CommonAuditor.cpp.

21 {
22 if ( caller ) after( evt, caller->name(), sc );
23 }
INamedInterface::name
virtual const std::string & name() const =0
Retrieve the name of the instance.
CommonAuditor::after
void after(StandardEventType evt, const std::string &caller, const StatusCode &sc) override
Definition: CommonAuditor.cpp:18
IOTest.evt
evt
Definition: IOTest.py:94

## ◆ Auditor() [1/2]

Auditor::Auditor

Constructor.

Parameters

  name | The algorithm object's name
  svcloc | A pointer to a service location service

Definition at line 12 of file Auditor.cpp.

12 : m_name( name ), m_pSvcLocator( pSvcLocator ) {}
Auditor::m_name
std::string m_name
Auditor's name for identification.
Definition: Auditor.h:129
Auditor::m_pSvcLocator
SmartIF< ISvcLocator > m_pSvcLocator
Pointer to service locator service.
Definition: Auditor.h:131
Auditor::name
const std::string & name() const override
Definition: Auditor.cpp:193

## ◆ Auditor() [2/2]

Auditor::Auditor
| delete

Constructor.

Parameters

  name | The algorithm object's name
  svcloc | A pointer to a service location service

## ◆ before() [1/4]

void CommonAuditor::before | ( | StandardEventType | evt,
|  | const std::string & | caller
| ) |  |
| override

Definition at line 7 of file CommonAuditor.cpp.

7 { before( toStr( evt ), caller ); }
toStr
const char * toStr(IAuditor::StandardEventType e)
Simple mapping function from IAuditor::StandardEventType to string.
Definition: IAuditor.h:99
CommonAuditor::before
void before(StandardEventType evt, const std::string &caller) override
Definition: CommonAuditor.cpp:7
IOTest.evt
evt
Definition: IOTest.py:94

## ◆ before() [2/4]

void CommonAuditor::before | ( | StandardEventType | evt,
|  | INamedInterface * | caller
| ) |  |
| override

Definition at line 4 of file CommonAuditor.cpp.

4 {
5 if ( caller ) before( toStr( evt ), caller->name() );
6 }
toStr
const char * toStr(IAuditor::StandardEventType e)
Simple mapping function from IAuditor::StandardEventType to string.
Definition: IAuditor.h:99
CommonAuditor::before
void before(StandardEventType evt, const std::string &caller) override
Definition: CommonAuditor.cpp:7
INamedInterface::name
virtual const std::string & name() const =0
Retrieve the name of the instance.
IOTest.evt
evt
Definition: IOTest.py:94

## ◆ before() [3/4]

void CommonAuditor::before | ( | CustomEventTypeRef | evt,
|  | const std::string & | caller
| ) |  |
| override

Definition at line 11 of file CommonAuditor.cpp.

11 {
12 if ( i_auditEventType( evt ) ) i_before( evt, caller );
13 }
CommonAuditor::i_auditEventType
bool i_auditEventType(const std::string &evt)
Check if we are requested to audit the passed event type.
Definition: CommonAuditor.h:42
CommonAuditor::i_before
virtual void i_before(CustomEventTypeRef evt, const std::string &caller)=0
catch all "before" method, implemented in the derived class
IOTest.evt
evt
Definition: IOTest.py:94

## ◆ before() [4/4]

void CommonAuditor::before | ( | CustomEventTypeRef | evt,
|  | INamedInterface * | caller
| ) |  |
| override

Definition at line 8 of file CommonAuditor.cpp.

8 {
9 if ( caller ) before( evt, caller->name() );
10 }
CommonAuditor::before
void before(StandardEventType evt, const std::string &caller) override
Definition: CommonAuditor.cpp:7
INamedInterface::name
virtual const std::string & name() const =0
Retrieve the name of the instance.
IOTest.evt
evt
Definition: IOTest.py:94

## ◆ deprecated_property()

void CommonAuditor::deprecated_property | ( | Gaudi::Details::PropertyBase & | p | ) |
| inline private

Definition at line 52 of file CommonAuditor.h.

52 {
53 if ( m_customTypes.size() > 0 ) {
54 if ( m_types.size() > 0 ) {
55 error() << p.name() << " is deprecated, but both " << m_customTypes.name() << " and " << m_types.name()
56 << " used." << endmsg;
57 throw GaudiException( "Property CustomEventTypes is deprecated, but both CustomEventTypes and EventTypes used",
58 this->name(), StatusCode::FAILURE );
59 } else {
60 warning() << p.name() << " " << p.documentation() << endmsg;
61 m_types = m_customTypes;
62 }
63 }
64 };
GaudiException
Define general base for Gaudi exception.
Definition: GaudiException.h:21
CommonMessagingBase::warning
MsgStream & warning() const
shortcut for the method msgStream(MSG::WARNING)
Definition: CommonMessaging.h:101
CommonAuditor::m_types
Gaudi::Property< std::vector< std::string > > m_types
Definition: CommonAuditor.h:66
Gaudi::Details::PropertyBase::name
const std::string name() const
property name
Definition: Property.h:36
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:98
CommonAuditor::m_customTypes
Gaudi::Property< std::vector< std::string > > m_customTypes
Definition: CommonAuditor.h:68
Auditor::name
const std::string & name() const override
Definition: Auditor.cpp:193
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
Gaudi::Details::PropertyBase::documentation
std::string documentation() const
property documentation
Definition: Property.h:38

## ◆ i_after()

virtual void CommonAuditor::i_after | ( | CustomEventTypeRef | evt,
|  | const std::string & | caller,
|  | const StatusCode & | sc
| ) |  |
| protected pure virtual

catch all "after" method, implemented in the derived class

Implemented in ChronoAuditor, MemoryAuditor, and NameAuditor.

## ◆ i_auditEventType()

bool CommonAuditor::i_auditEventType | ( | const std::string & | evt | ) |
| inline protected

Check if we are requested to audit the passed event type.

Definition at line 42 of file CommonAuditor.h.

42 {
43 // Note: there is no way to extract from a Property type the type returned by
44 // value().
45 const std::vector<std::string>& v = m_types.value();
46 // we need to return true is the list is empty or when the list does't
47 // start by "none" and the list contain the event we got.
48 return v.empty() || ( ( v[0] != "none" ) && ( find( v.begin(), v.end(), evt ) != v.end() ) );
49 }
std::vector::empty
T empty(T... args)
CommonAuditor::m_types
Gaudi::Property< std::vector< std::string > > m_types
Definition: CommonAuditor.h:66
std::vector::end
T end(T... args)
std::find
T find(T... args)
std::vector< std::string >
std::vector::begin
T begin(T... args)
IOTest.evt
evt
Definition: IOTest.py:94

## ◆ i_before()

virtual void CommonAuditor::i_before | ( | CustomEventTypeRef | evt,
|  | const std::string & | caller
| ) |  |
| protected pure virtual

catch all "before" method, implemented in the derived class

Implemented in MemStatAuditor, ChronoAuditor, MemoryAuditor, and NameAuditor.

## Member Data Documentation

## ◆ m_customTypes

Gaudi::Property<std::vector<std::string> > CommonAuditor::m_customTypes
| private

Initial value:
{
this, "CustomEventTypes", {}, &CommonAuditor::deprecated_property, " use EventTypes instead"}

Definition at line 68 of file CommonAuditor.h.

## ◆ m_types

Gaudi::Property<std::vector<std::string> > CommonAuditor::m_types
| private

Initial value:
{
this, "EventTypes", {}, "list of event types to audit ([]=all, ['none']=none)"}

Definition at line 66 of file CommonAuditor.h.

The documentation for this class was generated from the following files:

- GaudiAud/src/CommonAuditor.h
- GaudiAud/src/CommonAuditor.cpp